<?php
/**
 * swfuploadϴ
 *
 * @version        $Id: swfupload.php 1 16:22 2010720Z tianya $
 * @package        DedeCMS.Administrator
 * @copyright      Copyright (c) 2007 - 2010, DesDev, Inc.
 * @license        http://help.dedecms.com/usersguide/license.html
 * @link           http://www.dedecms.com
 */
require_once(dirname(__FILE__).'/config.php');
require_once(DEDEINC.'/image.func.php');
//ţ
require_once(DEDEINC.'/qiniu/autoload.php');
use Qiniu\Auth;
use Qiniu\Storage\UploadManager;
use Qiniu\Storage\BucketManager;
$auth = new Auth($cfg_qiniuak, $cfg_qiniusk);
$token = $auth->uploadToken($cfg_qiniubucket);
/************************
//ϴ
function Upload(){  }
*************************/
if(empty($dopost))
{
    ini_set('html_errors', '0');
    if ( empty($Filedata) || !is_uploaded_file($Filedata) )
    {
        echo 'ERROR: Upload Error! ';
        exit(0);
    }

    //ļƶʱĿ¼
    $tmpdir = DEDEDATA.'/uploadtmp';
    if(!is_dir($tmpdir))
    {
        MkdirAll($tmpdir, $cfg_dir_purview);
        CloseFtp();
        if(!is_dir($tmpdir))
        {
            echo "ERROR: Create {$tmpdir} dir Error! ";
            exit(0);
        }
    }
    
    $FiledataNew = str_replace("\\", '/', $Filedata);
    $FiledataNew = $tmpdir.'/'.preg_replace("/(.*)[\/]/isU", "", $FiledataNew);
    move_uploaded_file($Filedata, $FiledataNew);

    $info = $ftype = $sname = '';
    $srcInfo = GetImageSize($FiledataNew, $info);
    //ļ
    if (!is_array($srcInfo))
    {
        @unlink($Filedata);
        echo "ERROR: Image info Error! ";
        exit(0);
    }
    else
    {
        switch ($srcInfo[2])
        {
            case 1:
                $ftype = 'image/gif';
                $sname = '.gif';
                break;
            case 2:
                $ftype = 'image/jpeg';
                $sname = '.jpg';
                break;
            case 3:
                $ftype = 'image/png';
                $sname = '.png';
                break;
            case 6:
                $ftype = 'image/bmp';
                $sname = '.bmp';
                break;
        }
    }
    if($ftype=='')
    {
        @unlink($Filedata);
        echo "ERROR: Image type Error! ";
        exit(0);
    }
    
    //ԭͼ
    $filedir = $cfg_image_dir.'/'.MyDate($cfg_addon_savetype, time());
    if(!is_dir(DEDEROOT.$filedir))
    {
        MkdirAll($cfg_basedir.$filedir, $cfg_dir_purview);
        CloseFtp();
    }
    $filename = $cuserLogin->getUserID().'-'.dd2char(MyDate('ymdHis', time()));
    if( file_exists($cfg_basedir.$filedir.'/'.$filename.$sname) )
    {
        for($i=50; $i <= 5000; $i++)
        {
            if( !file_exists($cfg_basedir.$filedir.'/'.$filename.'-'.$i.$sname) )
            {
                $filename = $filename.'-'.$i;
                break;
            }
        }
    }
    $fileurl = $filedir.'/'.$filename.$sname;
    $rs = copy($FiledataNew, $cfg_basedir.$fileurl);
    unlink($FiledataNew);
    if(!$rs)
    {
        echo "ERROR: Copy Uploadfile Error! ";
        exit(0);
    }
    //WaterImg($cfg_basedir.$fileurl, 'up');
    $title = $filename.$sname;
//ţ
if($cfg_qiniu == 'Y')
{
	$uploadMgr = new UploadManager();
	$key = substr($filedir,1).'/'.$filename.$sname;
	list($ret, $err) = $uploadMgr->putFile($token, $key, $cfg_basedir.$fileurl);
}

    $inquery = "INSERT INTO `#@__uploads`(title,url,mediatype,width,height,playtime,filesize,uptime,mid)
        VALUES ('$title','".$cfg_qiniudomain.$fileurl."','$ftype','0','0','0','".filesize($cfg_basedir.$fileurl)."','".time()."','".$cuserLogin->getUserID()."'); ";
	if(!empty($arcid))
	{
		$inquery = "INSERT INTO `#@__uploads`(arcid,title,url,mediatype,width,height,playtime,filesize,uptime,mid)
        VALUES ('$arcid','$title','".$cfg_qiniudomain.$fileurl."','$ftype','0','0','0','".filesize($cfg_basedir.$fileurl)."','".time()."','".$cuserLogin->getUserID()."'); ";
	}
	
	$dsql->ExecuteNoneQuery($inquery);
    $fid = $dsql->GetLastID();
    AddMyAddon($fid, $fileurl);

    //ͼ
    ob_start();
    ImageResizeNew($cfg_basedir.$fileurl, $cfg_ddimg_width, $cfg_ddimg_height, '', false);
    $imagevariable = ob_get_contents();
    ob_end_clean();
    
    //Ϣ session
    if (!isset($_SESSION['file_info'])) $_SESSION['file_info'] = array();
    if (!isset($_SESSION['bigfile_info'])) $_SESSION['bigfile_info'] = array();
    if (!isset($_SESSION['fileid'])) $_SESSION['fileid'] = 1;
    else $_SESSION['fileid']++;
    
    $_SESSION['bigfile_info'][$_SESSION['fileid']] = $fileurl;
    $_SESSION['file_info'][$_SESSION['fileid']] = $imagevariable;
    echo "FILEID:".$_SESSION['fileid'];
    exit(0);
}
/************************
//ͼ
function GetThumbnail(){  }
*************************/
else if($dopost=='thumbnail')
{
    if( empty($id) )
    {
        header('HTTP/1.1 500 Internal Server Error');
        echo 'No ID';
        exit(0);
    }
    if (!is_array($_SESSION['file_info']) || !isset($_SESSION['file_info'][$id]))
    {
        header('HTTP/1.1 404 Not found');
        exit(0);
    }
    header('Content-type: image/jpeg');
    header('Content-Length: '.strlen($_SESSION['file_info'][$id]));
    echo $_SESSION['file_info'][$id];
    exit(0);
}
/************************
//ɾָIDͼƬ
*************************/
else if($dopost=='del')
{
    if(!isset($_SESSION['bigfile_info'][$id]))
    {
        echo '';
        exit();
    }

    $dsql->ExecuteNoneQuery("DELETE FROM `#@__uploads` WHERE url LIKE '".$cfg_qiniudomain.$_SESSION['bigfile_info'][$id]."'; ");
    @unlink($cfg_basedir.$_SESSION['bigfile_info'][$id]);
//ţ
if($cfg_qiniu == 'Y')
{
	$key = preg_replace('/\//','',$_SESSION['bigfile_info'][$id],1);
	$bucketMgr = new BucketManager($auth);
	$bucketMgr->delete($cfg_qiniubucket, $key);
}
    $_SESSION['file_info'][$id] = '';
    $_SESSION['bigfile_info'][$id] = '';
    echo "<b>ɾ</b>";
    exit();
}
/************************
//ȡͼƬַ
*************************/
else if($dopost=='addtoedit')
{
    if(!isset($_SESSION['bigfile_info'][$id]))
    {
        echo '';
        exit();
    }
//ţ
if($cfg_qiniu == 'Y')
{
	echo $cfg_qiniudomain.$_SESSION['bigfile_info'][$id];
}
else
{
	echo $_SESSION['bigfile_info'][$id];
}
	
	exit();
}
/************************
//ȡͼƬԤͼ
function GetddImg(){  }
*************************/
else if($dopost=='ddimg')
{
    //ͼ
    ob_start();
    if(!preg_match("/^(http:\/\/)?([^\/]+)/i", $img)) $img = $cfg_basedir.$img;
    ImageResizeNew($img, $cfg_ddimg_width, $cfg_ddimg_height, '', false);
    $imagevariable = ob_get_contents();
    ob_end_clean();
    header('Content-type: image/jpeg');
    header('Content-Length: '.strlen($imagevariable));
    echo $imagevariable;
    exit();
}
/************************
//ɾָͼƬ(༭ͼʱ)
*************************/
else if($dopost=='delold')
{
//ţ
if($cfg_qiniu == 'Y')
{
	$picfile = str_replace($cfg_qiniudomain, '', $picfile);
	$key = preg_replace('/\//','',$picfile,1);
	$bucketMgr = new BucketManager($auth);
	$bucketMgr->delete($cfg_qiniubucket, $key);
}
    $imgfile = $cfg_basedir.$picfile;
    if(file_exists($imgfile) && !is_dir($imgfile) && preg_match("#^".$cfg_medias_dir."#", $picfile))
    {
        @unlink($imgfile);
    }
    $dsql->ExecuteNoneQuery("DELETE FROM `#@__uploads` WHERE url LIKE '".$cfg_qiniudomain.$picfile."'; ");
    echo "<b>ɾ</b>";
    exit();
}